﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;

namespace MyDNSUpdate
{
    class DDNSController
    {
        List<DDNSClient> clients = new List<DDNSClient>();

        public DDNSController(Settings settings)
        {
            Clear();
            CreateClients(settings);
        }

        public void CreateClients(Settings settings)
        {
            foreach (AccountSettings setting in settings.Accounts) {
                clients.Add(new DDNSClient(setting, settings.RetryInterval));
            }
        }

        public void Clear()
        {
            clients.Clear();
        }

        public DDNSClient.DDNSClientResult[] Check(IPAddress addr, bool force)
        {
            DDNSClient.DDNSClientResult[] ret = new DDNSClient.DDNSClientResult[clients.Count];

            //foreach (DDNSClient client in clients) {
            for ( int c = 0; c < clients.Count; c++ ) {
                if (clients[c].Enabled) ret[c] = clients[c].Check(addr, force);
                else ret[c] = DDNSClient.DDNSClientResult.NOACTION;
            }

            return ret;
        }

        public bool GetLastLog(int idx, ref string log)
        {
            if (idx >= clients.Count) return false;
            if (!clients[idx].Enabled) return false;

            clients[idx].GetLastLog(out log);
            return true;
        }
    }
}
