﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MyDNSUpdate
{
    public partial class Form2 : Form
    {
        public AccountSettings account;

        public Form2(AccountSettings account_I)
        {
            InitializeComponent();
            account = account_I;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            UpdateState();
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            dataGridView1.DataSource = account.detail.HTTPParams;
            textBoxTitle.Text = account.Title;
            checkBoxEnabled.Checked = account.Enabled;
            textBoxURL.Text = account.detail.URL;
            textBoxOK.Text = account.detail.OK;
            checkBoxBasic.Checked = account.detail.BasicAuth;
            textBoxUserName.Text = account.detail.Username;
            textBoxPassword.Text = account.detail.Password;
            timeSpanPickerInterval.ValueTimeSpan = account.Interval;
            timeSpanPickerInterval.MinimumValue = TimeSpan.FromHours(1);

            UpdateState();
        }

        private void Form2_FormClosed(object sender, FormClosedEventArgs e)
        {
            account.Title = textBoxTitle.Text;
            account.Enabled = checkBoxEnabled.Checked;
            account.detail.URL = textBoxURL.Text;
            account.detail.OK = textBoxOK.Text;
            account.detail.BasicAuth = checkBoxBasic.Checked;
            account.detail.Username = textBoxUserName.Text;
            account.detail.Password = textBoxPassword.Text;
            account.Interval = timeSpanPickerInterval.ValueTimeSpan;
        }

        private void UpdateState()
        {
            bool enabled = checkBoxBasic.Checked;
            textBoxUserName.Enabled = enabled;
            textBoxPassword.Enabled = enabled;
        }

        private void buttonAdd_Click(object sender, EventArgs e)
        {
            account.detail.HTTPParams.Add(new Parameters());
        }

        private void buttonDelete_Click(object sender, EventArgs e)
        {
            if (dataGridView1.SelectedRows.Count == 0) return;
            foreach (DataGridViewRow r in dataGridView1.SelectedRows) {
                account.detail.HTTPParams.RemoveAt(r.Index);
            }
        }
    }
}
